! linkmenu.h
! sistema di menu per linklib.h
! Paolo Lucchesi, 2014-2015

System_File;

Default MENUBACKSTRING "Torna indietro"; ! La posso ridefinire
Global menuforceexit = false;

Global gg_menuwin;
#IfNDef MENUONMAINWIN;
Constant GG_MENUWIN_ROCK 291;
#IfDef STATUS_WIN_UFRAME;
  Constant GG_MENUWINUF_ROCK 292;
  Global gg_menuwinuf = 0;
#EndIf;
#EndIf;

Class Menu
  with show [; ShowMenu(self); ];

Object menubackobject 
  with short_name MENUBACKSTRING,
    description [; rfalse; ];

[ ShowMenu id clear; return(_ShowMenu(id, clear)); ];

#IfDef MENUONMAINWIN;
[ _ShowMenu id;
  gg_menuwin = gg_mainwin;
  menuforceexit = false;
  ShowRecMenu(id);
  glk_window_clear(gg_mainwin); printedloc = 0;
];

#IfNot; ! ~MENUONMAINWIN

[ _ShowMenu id clear;
  if (clear) { glk_window_clear(gg_mainwin); printedloc = 0; }
  if (gg_menuwin == 0) {
    gg_menuwin=glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Proportional), 90, wintype_Textbuffer, GG_MENUWIN_ROCK);
  }
  DrawMenuFrame();
  glk_set_window(gg_menuwin);
  menuforceexit = false;
  ShowRecMenu(id);
  CloseMenuFrame();
  if (gg_menuwin) glk_window_close(gg_menuwin);
  gg_menuwin = 0;
  glk_set_window(gg_mainwin); 
  if (clear) print "^^";
];

#IfDef STATUS_WIN_UFRAME;
[ DrawMenuFrame fg bg;
    bg = 0; fg = $FFFFFF;
    if (gs_graphic) {
    ! Se e' definita la costante STATUS_WIN_UFRAME e l'interprete supporta
    ! la grafica, creo una piccola finestra grafica con una linea per separare 
    ! la finestre principale dalla statusline
        if (glk_style_measure(gg_statuswin, style_Normal, stylehint_TextColor, gg_arguments)) 
            fg = gg_arguments --> 0;
        if (glk_style_measure(gg_statuswin, style_Normal, stylehint_BackColor, gg_arguments)) 
            bg = gg_arguments --> 0;
        if (gg_menuwinuf == 0) {
            gg_menuwinuf = glk_window_open(gg_menuwin, (winmethod_Above+winmethod_Fixed), 4, wintype_Graphics, GG_MENUWINUF_ROCK);
        }    
        glk_window_set_background_color(gg_menuwinuf, bg); 
        glk_window_clear(gg_menuwinuf);        
        glk_window_fill_rect(gg_menuwinuf,fg,1,1,4096,2);
    }
];

[ CloseMenuFrame;
    if (gg_menuwinuf) glk_window_close(gg_menuwinuf);
    gg_menuwinuf = 0;
];
#EndIf;
Stub DrawMenuFrame 0;
Stub CloseMenuFrame 0;

#EndIf; ! MENUONMAINWIN
  
[ ShowRecMenu id; return(_ShowRecMenu(id)); ];

[ _ShowRecMenu id x lflg;
  lflg=true;
  while(lflg) {
    glk_window_clear(gg_menuwin);
    glk_set_window(gg_menuwin);
    SetStyle(style_Header);
    print "^",(name)id; print "^^";
    SetStyle(style_Normal);
    if (id provides description) id.description();
    if (menuforceexit) rtrue;
    objectloop(x in id) {
      if (x hasnt locked)
        if (x provides condition && ~~x.condition()) ;
        else { print "^"; link(x); print (name)x; link(0); print "^"; }
    }
    move menubackobject to id;
    print "^"; link(menubackobject); print (name)menubackobject; link(0);
    print "^";
    while(true) {
      x = 0;
      while (x == 0) x = GetLinkKey();
      if (x == menubackobject) { lflg=false; break; }
      if (x <= 0) {
        if (keypressed == keycode_Escape) lflg=false;
        break;
      }
      if (x in id) { ShowRecMenu(x); break; }
    }
    remove menubackobject;
    if (menuforceexit) rtrue;
    !print "Now ", (name)id, " lflf=", lflg,"^";
  }
];

[ ShowOptions id clear lflg x;
#IfDef MENUONMAINWIN;
  gg_menuwin = gg_mainwin;
  clear = true;
#IfNot; 
  if (clear) { glk_window_clear(gg_mainwin); printedloc = 0; }
  if (gg_menuwin == 0) {
    gg_menuwin=glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Proportional), 90, wintype_Textbuffer, GG_MENUWIN_ROCK);
  }
  DrawMenuFrame();
  glk_set_window(gg_menuwin);
#EndIf;
  lflg=true;
  objectloop(x in id) {
    if (x hasnt locked)
      if (x provides condition && ~~x.condition()) ;
      else if (x provides react_before) x.react_before();
  }  
  while(lflg) {
    glk_window_clear(gg_menuwin);
    objectloop(x in id) {
      if (x hasnt locked)
        if (x provides condition && ~~x.condition()) ;
        else { 
            print "^"; link(x); print (name)x; 
            if (x has on) print " [On]"; else print " [Off]";
            link(0); print "^";
        }
    }  
    print "^"; link(menubackobject); print (name)menubackobject; link(0);
    while(true) {
      x = 0;
      while (x == 0) x = GetLink();
      if (x == menubackobject) { lflg=false; break; }
      if (x <= 0) {
        if (keypressed == keycode_Escape) lflg=false;
        break;
      }
      if (x in id) { 
        if (x has on) give x ~on; else give x on;
        break;
      }
    }
  }
  objectloop(x in id) {
    if (x hasnt locked)
      if (x provides condition && ~~x.condition()) ;
      else if (x provides react_after) x.react_after();
  }  
#IfDef MENUONMAINWIN;
  glk_window_clear(gg_mainwin); printedloc = 0;
#IfNot;  
  if (gg_menuwin) glk_window_close(gg_menuwin);
  gg_menuwin = 0;
  CloseMenuFrame();
  glk_set_window(gg_mainwin); 
  if (clear) print "^^";
#EndIf;
];

#IfNDef MENUONMAINWIN;
Object "linkmenu" LibraryExtensions
  with request [; if (gg_menuwin) glk_request_hyperlink_event(gg_menuwin); ],
    idglkobject [phase type ref rock;
        if (phase == 0) gg_menuwin = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_MENUWIN_ROCK)) { gg_menuwin = ref; rtrue; }
        if (phase == 2 or 3) { if (gg_menuwin) glk_window_close(gg_menuwin); gg_menuwin=0 ;}
#IfDef STATUS_WIN_UFRAME;
        if (phase == 0) gg_menuwinuf = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_MENUWINUF_ROCK)) { gg_menuwinuf = ref; rtrue; }
        if (phase == 2 or 3) { if (gg_menuwinuf) glk_window_close(gg_menuwinuf); gg_menuwinuf=0 ;}
#Endif;          
        rfalse;
    ];
#EndIf;
