! linksys.h
! classi particolari di linklib.h
! Paolo Lucchesi, 2014-2015

System_File;

[ SetStyle sy;
  currentstyleglk=sy;
  return(glk_set_style(sy));
];

[ GetStyle; return(currentstyleglk); ];

!!! Qui si dovrebbe impostare un sistema per gestire piu' toolaction
#IfDef AUTOTOOL;
Object toolaction has locked;
#IfNot;
Action toolaction
  with 
    condition [; 
        if (parent(toolaction) == 0) rfalse;
        return (parent(toolaction) in player); 
    ],
    short_name [;
        print "Utilizza ";
        PrintArtName(parent(toolaction));
        rtrue;
    ],
    description [;
        if (usedtool==parent(toolaction)) "Stai gi@`a utilizzando ", (artname)parent(toolaction), ".";
        usedtool=parent(toolaction);
        "Ok.";
    ];
#Endif;

    
[ IsUsed id;
#IfDef AUTOTOOL;
    if (id in player) rtrue;
#IfNot;
    if (toolmode == 0 && id in player) rtrue;
    if (id == usedtool && id in player) rtrue;
#EndIf;
    rfalse;
];

[ PrintShortName o;
    if (o provides short_name) { PrintRun(o, short_name); rtrue; }
    print (object) o;
];

[ PrintLinkName o;
    if (o provides link_name) { PrintRun(o, link_name); rtrue; }
    print (name) o;
];

[ PrintAction o;
  if (o ofclass Action && o hasnt locked)
    if (o provides condition && ~~o.condition()) ;
     else { link(o); print (name)o; link(0); print "^"; }
];

[ PrintActionFrom o x;
  objectloop(x in o) PrintAction(x);
];

[ linkname o; return(PrintLinkName(o)); ];

[ link id; 
    ! funzione o print rule
    ! link(x) inizia l'hyperlink dell'oggetto x
    ! link(0) chiude l'hyperlink
    if (id == 0) glk_set_hyperlink(0);
    if (metaclass(id) == Object) glk_set_hyperlink(id); 
];

[ lend; link(0); ]; ! chiude l'hyperlink

[ lname id;
    ! print rule: stampa come hyperlink il nome o lo short_name
    ! dell'oggetto id
    link(id);
    if (id provides link_name) PrintRun(id, link_name);
    else print (name)id;
    link(0);
];

[ ltext id txt;
    ! funzione che stampa come hyperlink relativo a id il testo txt
    ! ha due argomenti, quindi per usarla cone printrule, si deve usare 
    ! la printrule generica: (rule)ltext(id,"testo");
    link(id);
    print (string)txt;
    link(0);
];

[ PrintArticle id flag n;
    ! Stampo l'articolo
    if (id provides article) {
        n = id.#article / WORDSIZE;
        if (flag >= n) flag=n-1;
        print (string)id.&article-->flag;
    }
    ! servirebbe una printorrun
    !PrintAnyToArray(GenString + WORDSIZE, 160, id.short_name);
    !n = LanguageContraction(GenString);
];

[ PrintArtName id flag;
    PrintArticle(id,flag);
    print (name)id;
];

[ artname id;
  ! Stampo l'articolo e il nome dell'oggetto x
  !if (x provides article) print (string)x.article; 
  PrintArticle(id, 0);
  print (name)id;
];

[ indname id;
  ! Stampo l'articolo e il nome dell'oggetto x
  !if (x provides article) print (string)x.article; 
  PrintArticle(id, 1);
  print (name)id;
];

[ lartname id;
    ! print rule: stampa come hyperlink il nome o lo short_name
    ! dell'oggetto id
    link(id);
    PrintArticle(id, 0);
    if (id provides link_name) PrintRun(id, link_name);
    else print (name)id;
    link(0);
];

[ lindname id;
    ! print rule: stampa come hyperlink il nome o lo short_name
    ! dell'oggetto id
    link(id);
    PrintArticle(id, 1);
    if (id provides link_name) PrintRun(id, link_name);
    else print (name)id;
    link(0);
];

[ PrintRun obj prop r;
  r = true;
  if (prop) {
      if (obj.prop ofclass String) print (string)obj.prop;
      if (obj.prop ofclass Object) print (name)obj.prop;
      if (obj.prop ofclass Routine) r = obj.prop();
  } else {
      if (obj ofclass String) print (string)obj;
      if (obj ofclass Object) print (name)obj;
      if (obj ofclass Routine) r = obj();
  }  
  return r;
];

[ PrintCommand id noexam x k;  
  k = 1;
  ! Controllo se le estensioni hanno un loro modo di scrivere il comando
  objectloop (x in LibraryExtensions) {
    if (x provides command) {
      if (x.command(id)) {k = 0; continue;}
    }
  }        
  ! Scrivo il comando associato, o esamina id
  if (k && id provides command) if (id.command()) k = 0;
  if (k && id ofclass Action) { k=0; print (name)id, "^"; }
  if (k) {
    if (~~noexam) print "Esamina ";
    print (artname)id, "^";
  }
];

[ rule x; x=x; ]; ! printrule generica

[ ClearWindow;
  glk_window_clear(gg_mainwin);
];

[ GetString buf len;
    glk_request_line_event(gg_mainwin, buf+WORDSIZE, len-WORDSIZE, 0);
    while(true) {
      glk_select(gg_event);
      if (gg_event-->0 == evtype_LineInput) rtrue;
    }
];

![ LinkLibSquasher;
!    PrintShortName(); LinkLibSquasher(); 
!];